import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import java.util.Scanner;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    //@Rule
    //public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Test
    public void testStringFromInt() throws Exception {

        assertThat(Conditional.stringFromInt(2500).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(7).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(2).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(1).toLowerCase(), is("one"));
        assertThat(Conditional.stringFromInt(0).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(-1).toLowerCase(), is("one"));
        assertThat(Conditional.stringFromInt(-2).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(-3).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(-2000).toLowerCase(), is("not one"));
        assertThat(Conditional.stringFromInt(-2001).toLowerCase(), is("not one"));

    }

    @Test
    public void testIntFromString() throws Exception {

        String words = "it is not a question of yes or no";
        Scanner sc = new Scanner(words);

        while (sc.hasNext()) {
            String word = sc.next();
            if (word.equals("yes")) {
                assertThat(Conditional.intFromString(word), is(2));
            } else if (word.length() > 1) {
                assertThat(Conditional.intFromString(word), is(1));
            } else {
                assertThat(Conditional.intFromString(word), is(0));
            }
        }

    }

    @Test
    public void testStringFromBools() throws Exception {

        assertThat(Conditional.stringFromBools(true, true), is("!"));
        assertThat(Conditional.stringFromBools(false, true), is("!one"));
        assertThat(Conditional.stringFromBools(true, false), is("!one"));
        assertThat(Conditional.stringFromBools(false, false), is("none!"));

    }

    @Test
    public void testIntFromBool() throws Exception {

        assertThat(Conditional.intFromBool(true), is(1));
        assertThat(Conditional.intFromBool(false), is(2));

    }

    @Test
    public void testIntRec() throws Exception {

        assertThat(Conditional.rec(1), is(1L));
        assertThat(Conditional.rec(2), is(1L));
        assertThat(Conditional.rec(3), is(3L));
        assertThat(Conditional.rec(4), is(3L));
        assertThat(Conditional.rec(5), is(15L));
        assertThat(Conditional.rec(6), is(15L));
        assertThat(Conditional.rec(7), is(105L));
        assertThat(Conditional.rec(8), is(105L));
        assertThat(Conditional.rec(9), is(945L));
        assertThat(Conditional.rec(10), is(945L));
        assertThat(Conditional.rec(23), is(316234143225L));
        assertThat(Conditional.rec(24), is(316234143225L));

    }


}